/* time.h --- MicroBenchmark library. */
/*
 * Copyright © 2023 Miguel Ángel Arruga Vivas <rosen644835@gmail.com>
 *
 * This file is part of MicroBenchmark.
 *
 * MicroBenchmark is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3 of
 * the License, or (at your option) any later version.
 *
 * MicroBenchmark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with MicroBenchmark.  If not, see
 * <http://www.gnu.org/licenses/>.
 */
#ifndef MICRO_BENCHMARK_INTERNAL_TEST_CONSTRAINTS_TIME_H
#define MICRO_BENCHMARK_INTERNAL_TEST_CONSTRAINTS_TIME_H

#include "mbenchmark/common.h"
#include "mbenchmark/clock/time.h"
#include "mbenchmark/clock/timer-provider.h"

/* *INDENT-OFF* */
MICRO_BENCHMARK_BEGIN_DECLS
/* *INDENT-ON* */

typedef struct micro_benchmark_test_timer_constraint_
{
  bool has_timer;
  micro_benchmark_clock_type type;
  micro_benchmark_timer_provider provider;
  micro_benchmark_timer tmpl;
  micro_benchmark_chronometer_provider chrono_provider;
  micro_benchmark_meter chrono_tmpl;
} mbtest_timer_constraint_;

typedef struct micro_benchmark_test_time_constraint_
{
  bool has_deadline;
  micro_benchmark_clock_time deadline;
  mbtest_timer_constraint_ deadline_timer;

  bool has_sample_time;
  micro_benchmark_clock_time sample_time;
  mbtest_timer_constraint_ sample_timer;
} mbtest_time_constraint_;

MICRO_BENCHMARK_END_DECLS
#endif
